/*  Header file to define tree and node structures         */
#ifndef _TREE_H_
#define _TREE_H_

#define MAX_NAME_LEN 256
#define MAX_INDEL_SIZE 100	/*CS:*/

typedef struct TNode TNode;
struct TNode {
	TNode *branch0, *branch1, *branch2, *next, *anc;
	double length0, length1, length2, param;
	int tipNo;
	
	char *sequence;

	short *invariable;	/*CS: An array to carry the invariable sites, as well as the non-indel sites */
	double *siteRates;	/*CS: Not sure if we will do the gamma-rate heterogeneity, but may try. */
	double *gammaRates;	/*CS: Making indels, there is no easy way that we can use a single array to keep */
	short *categories;	/* track of the gammas, categories, site, and invar rates.  Thus, each node carries */
        int indels;     /*CS: to make a corrective term that alters numBases
                         * if insertions or deletions happen on a sequence.  This term
                         * is inherited by the ancestor nodes, since the sequences will
                         * remain changed. */
	int mytipNo;
};


typedef struct TTree TTree;
struct TTree {
	int rooted, lengths;
	TNode *root, *nodeList;
	int numTips, numNodes;
	double totalLength;
	char **names;
	TNode **tips;
	int capacity;

	/*CS: indel variables*/
	short do_indels;	/*CS: If the tree has indels, this is 1.  Otherwise, 0. */
	double P_ins_;
	double P_del_;
	int maxIndel;
	double *insert_lengthDistribution;
	double *delete_lengthDistribution;
};

#endif /* _TREE_H_ */

